﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data.OleDb;
using System.Data;
using C1.WPF.FlexGrid;

namespace WPF_Flex_Merging
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            string connString = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + @"\ComponentOne Samples\Common\C1NWind.mdb";
            OleDbConnection conn = new OleDbConnection(connString);
            OleDbCommand comm = new OleDbCommand("Select * from Products", conn);
            OleDbDataAdapter adap = new OleDbDataAdapter(comm);
            DataSet ds = new DataSet();
            adap.Fill(ds);
            c1FlexGrid1.ItemsSource = ds.Tables[0].AsDataView();

            c1FlexGrid1.AllowMerging = C1.WPF.FlexGrid.AllowMerging.Cells;
            MyMergeManager mmg = new MyMergeManager();
            c1FlexGrid1.MergeManager = mmg;

            myCellfactory mcf = new myCellfactory();
            c1FlexGrid1.CellFactory = mcf;

            C1.WPF.FlexGrid.CellStyle cs = new C1.WPF.FlexGrid.CellStyle();
            cs.HorizontalAlignment = HorizontalAlignment.Center;
            cs.VerticalAlignment = VerticalAlignment.Center;

            this.c1FlexGrid1.Columns["SupplierId"].CellStyle = cs;
            this.c1FlexGrid1.Columns["UnitsOnOrder"].CellStyle = cs;
            this.c1FlexGrid1.Columns["ReorderLevel"].CellStyle = cs;
        }
    }
    public class MyMergeManager : IMergeManager
    {
        public CellRange GetMergedRange(C1FlexGrid grid, CellType cellType, CellRange rg)
        {
            // we are only interested in data cells
            // (not merging row or column headers)
            if (cellType == CellType.Cell)
            {
                // expand up/down
                for (int i = rg.Row; i < grid.Rows.Count - 1; i++)
                {
                    if (GetDataDisplay(grid, i, rg.Column) != GetDataDisplay(grid, i + 1, rg.Column)) break;
                    rg.Row2 = i + 1;
                }
                for (int i = rg.Row; i > 0; i--)
                {
                    if (GetDataDisplay(grid, i, rg.Column) != GetDataDisplay(grid, i - 1, rg.Column)) break;
                    rg.Row = i - 1;
                }
            }
            return rg;
        }
        string GetDataDisplay(C1FlexGrid grid, int r, int c)
        {
            return grid[r, c].ToString();
        }
    }
    public class myCellfactory : CellFactory
    {
        public override void CreateCellContent(C1FlexGrid grid, Border bdr, CellRange rng)
        {
            base.CreateCellContent(grid, bdr, rng);
            var tb = bdr.Child as TextBlock;

            if (tb != null && rng.Column == 2 || rng.Column == 7 || rng.Column == 8)
            {
                ContentPresenter cp = (VisualTreeHelper.GetParent(tb) as ContentPresenter);
                System.Windows.Media.RotateTransform rotateTransform = new RotateTransform();
                rotateTransform.Angle = 50;
                tb.LayoutTransform = rotateTransform;
                bdr.Background = Brushes.PaleGreen;
                tb.Foreground = Brushes.Blue;
            }
        }
    }
}
